Subject: RE: New LDUP requirements draft

From: "Steven Legg" <[email-masked]>
Date: Wed, 4 Apr 2001 17:14:24 +1000

Ryan,

Ryan Moats wrote:
> See <rm>...</rm> inline below...  Ryan
>
> Rick,
>
> Richard V Huber wrote:
> > This started out as a reply to Steven Legg's message, but I
> > guess it is
> > now also a reply to Tim Hahn, Ed Reed, and Kurt Zeilenga.
> >
> > P7 is a protocol requirement.  The change between previous
> drafts and
> > draft -07 was to make it clearer what atomicity information
> has to be
> > carried by the protocol.
>
> In my opinion, the requirement is now less clear. The
> requirement might
> now clarify what atomicity information has to be carried by
> the protocol
> but we've lost the immediate context that we are talking
> about "atomicity
> information that must be carried in the protocol". It don't
> think it is
> enough to expect readers will fill in the missing context by noting it
> is a *protocol* requirement.
>
> <rm>Steve, you've totally lost me here.  I don't see where the context
> has been lost.  The section talks about protocol and it say
> specifically
> what the protocol must carry.  I disagree that it is less clear.</rm>

Can you please point me at the sentence in the section that specifically
says
that P7 is about "what the protocol must carry"? I can't seem to find it.
Other requirements in the same section have consequences that go beyond just
what the protocol must carry. It is not unreasonable for the reader to
assume
that P7 might also have wider consequences. The way P7 now reads suggests to
me some unintended serious consequences for the architecture and the
conflict
resolution mechanism.

> > I don't think this clarification makes it
> > inconsistent with other parts of the document.
>
> Given the understanding that P7 is still about what atomicity
> information is
> required to be carried in the protocol then I agree that it
> is consistent
> with other parts of the document, but my problem is that I believe the
> current wording suggests other (possibly inconsistent)
> interpretations.
> A casual reader might not notice that their interpretation doesn't
> fit with the rest of the document. Each requirement should be clear
> and able to stand on its own without having to analyse the other
> requirements to weed out the correct interpretation.
>
> <rm>I saw a similar problem with the previous version and
> so we added the reference to RFC 2251 specifically to provide some
> clarity.  Are you asking for "LDAP operations" to be replaced by
> "LDAP modify operations"?</rm>

No. I want P7 to be rewritten so that it no longer seems to be imposing
a requirement on the conflict resolution mechanism, i.e. URP, to maintain
the atomicity of LDAP operations.

I remain unconvinced that P7 clearly says what you mean it to say.
We may have to agree to disagree.

By the way, RFC 2251 only mentions atomicity in the context of the
set of modifications in a Modify Request. The atomicity requirements
for other operations are unstated. The same situation applies in X.511.
Conventional wisdom is that all LDAP and DAP update operations are
atomic, but none of the specifications make that clear.

Regards,
Steven

---

From: "Ryan Moats" <[email-masked]>
Date: Wed, 4 Apr 2001 08:54:56 -0500

<rm2>...</rm2> inline below... Ryan

-----Original Message-----
Ryan,

<rm2>To me, the word "protocol" means only "protocol".  If you are
becoming confused that other requirements in the section are not
limited in their wording to the protocol, then that is something
that needs to be examined.  Taking a fresh look at section 4.3, the
only requirement that I see as possibly having consequences outside
of the scope of the protocol is P3. This needs to be reworded or moved
to the model section. This is consistent with previous changes where
requirements were moved from the protocol section when it became
clear that they covered more than just the protocol.</rm2>

<rm2>We may indeed have to agree to disagree.  I think it is reasonable
to say that the replication protocol (not the resolution procedures,
not ...) should maintain the same atomicity information that is
available via LDAP itself.</rm2>